#include <Adafruit_CircuitPlayground.h>

#include <iostream>
#include <string>
using namespace std;

#define BLYNK_TEMPLATE_ID "TMPLqVvh2jd"
#define BLYNK_DEVICE_NAME "Amit device"
#define BLYNK_AUTH_TOKEN "0UtBsNEEN316TnjQo4Af-dEFp93MwL-E"

// Comment this out to disable prints and save space
#define BLYNK_PRINT SerialUSB

#include <ESP8266_Lib.h>
#include <BlynkSimpleShieldEsp8266.h>
#include <Adafruit_CircuitPlayground.h>

char auth[] = BLYNK_AUTH_TOKEN;

// Your WiFi credentials.
// Set password to "" for open networks.
char ssid[] = "amitamar";
char pass[] = "";

// Hardware Serial on Mega, Leonardo, Micro...
#define EspSerial Serial1

// or Software Serial on Uno, Nano...
//#include <SoftwareSerial.h>
//SoftwareSerial EspSerial(2, 3); // RX, TX

// Your ESP8266 baud rate:
#define ESP8266_BAUD 115200

ESP8266 wifi(&EspSerial);

//booleans for finish the exericeses
bool finishExHand1 = false;
bool finishExHand2 = false;
bool finishExLeg1 = false;
bool finishExLeg2 = false;

//important Varibels from exerices1
double ArraymaxAngeleFromEx1 [4];
double maxAngeleFromEx1 = -180;
int ArrayCountNumFromEx1 [4];

//important Varibels from exerices2
bool theUserSteelWithTheHandUp [4] = {true, true, true, true};

//important Varibels from exerices3
double ArraymaxAngeleFromEx3 [4];
double maxAngeleFromEx3 = -180;
int ArrayCountNumFromEx3 [4];

//important Varibels from exerices4
bool theUserSteelWithTheLegUp [4] = {true, true, true, true};

//result varieble that we send to Blink
String result;

//counter for the main loop
int counter = 0;

//boolean for the loop to get inforamtion from integromat to cpx
bool fromIntegromatToCpx = false;

//indication for the process from the last results with the hand angle
int processFromLastTimeHand = 2;

//indication for the process from the last results with the leg angle
int processFromLastTimeLeg = 2;


void setup() {
  // put your setup code here, to run once:
  CircuitPlayground.begin();
  // Debug console
  SerialUSB.begin(115200);

  // Set ESP8266 baud rate
  EspSerial.begin(ESP8266_BAUD);
  delay(10);

  Blynk.begin(auth, wifi, ssid, pass);
  // You can also specify server:
  //Blynk.begin(auth, wifi, ssid, pass, "blynk.cloud", 80);
  //Blynk.begin(auth, wifi, ssid, pass, IPAddress(192,168,1,100), 8080);
}


void loop() {
  
    Blynk.run();

   //start the iteration
   if(CircuitPlayground.slideSwitch()) {

        //if it's the first time of the loop turn of the lights
        if(counter == 0)
        {
         for(int i=0 ; i<10 ; i++){
            CircuitPlayground.setPixelColor(i, 0, 0, 0);
          }
        }
    
        //the user wants to work on his hand
        if(CircuitPlayground.rightButton()) {
          delay(300);
          //the user wants to do the exirces 2 for the hand
          if(CircuitPlayground.rightButton()) {
            Serial.println("starting the ex2 for hand");
            finishExHand2 = exHand2();
        }  
        else {
          //the user wants to do the exirces 1 for the hand
          Serial.println("starting the ex1 for hand");
          finishExHand1 = exHand1();
        }
      }
      if(finishExHand1 && finishExHand2) {
        CircuitPlayground.setPixelColor(4, 0, 0, 255);
      }
      //the user wants to work on his hand
      if(CircuitPlayground.leftButton()) {
            delay(300);
            //the user wants to do the exirces 2 for the leg
            if(CircuitPlayground.leftButton()) {
              Serial.println("L2");
              finishExLeg2 = exLeg2();
          }  
          else {
            //the user wants to do the exirces 1 for the leg
            Serial.println("L1");
            finishExLeg1 = exLeg1();
          }
        }
         if(finishExLeg1 && finishExLeg2) {
            CircuitPlayground.setPixelColor(5, 0, 0, 255);
      }
      counter ++;
    }

    //if the slide switch is on the other side and it's not the first time, show the user the process from the last time
    if(!CircuitPlayground.slideSwitch() && fromIntegromatToCpx)
    {

      //shut down the lights
      for(int i=0 ; i<10 ; i++){
         CircuitPlayground.setPixelColor(i, 0, 0, 0);
       }
 
      delay(1000);
      
      //processFromLastTime is the proces with the hand angele from last time 
      processFromLastTimeHand = map(processFromLastTimeHand, -20, 20, 0, 4);
      processFromLastTimeLeg = map(processFromLastTimeLeg, -20, 20, 5, 9);


      //turn the lights according the procces with the amgle of the hand
      for(int i = 0; i <= processFromLastTimeHand; i++) {
        CircuitPlayground.setPixelColor(i, 255, 255, 0);
      }


      //turn the lights according the procces with the amgle of the leg
      for(int j = 9; j >= processFromLastTimeLeg; j--) {
        CircuitPlayground.setPixelColor(j, 255, 165, 0);
      }

      //we want the condition will be false until the user finish another session of the exercises 
      fromIntegromatToCpx = false;

      Serial.print("from intergromat hand proces");
      Serial.println(processFromLastTimeHand);

      Serial.print("from intergromat leg proces");
      Serial.println(processFromLastTimeLeg);

      //if the user switch the slidw switch to the other side, the loop start from begining
      counter = 0;
    }
    
    //the user had finished the exercises and the results sends to blink
    if(finishExHand1 && finishExHand2 && finishExLeg1 && finishExLeg2){
      //function to concat results to one string
      writeData();
      Serial.println(result);
      //sending to blibk the resuts
      Blynk.virtualWrite(V6 , result);
      //initilaize the all exercises to false
      finishExHand1 = false;
      finishExHand2 = false;
      finishExLeg1 = false;
      finishExLeg2 = false;
      //turn off the lights
      for(int i = 0; i < 10; i++) {
        CircuitPlayground.setPixelColor(i, 0, 0, 0);
      }
      fromIntegromatToCpx = true;
   }
} 
 

bool exLeg1() {
    delay(1500);
    //varible declarations
    double tempMaxAngeleFromEx3 = 0;
    int iterator = 0;
    int counter = 0;
    unsigned long startEx = millis();
    unsigned long previousMillis1 = millis() + 15000;
    unsigned long previousMillis2 = millis(); 
    unsigned long currentMillis = millis();
    //the exerise should be 2 minutes
    while(currentMillis - startEx < 12500) {
      Blynk.run();
      currentMillis = millis();
      //every 15 secoends the user should stop / continue the exerices
      if(currentMillis - previousMillis1 > 15000) {
        //that how the user know to stop / continue the exerices
        CircuitPlayground.playTone(300, 200, false);
        previousMillis1 = currentMillis;
      }
      //measure the max angel for every interval of 30 seconds, and saving this data into array for the therpiset
       if(currentMillis - previousMillis2 > 30000) {
        Serial.println("MAXXXXXXXX");
        ArraymaxAngeleFromEx3[iterator] = tempMaxAngeleFromEx3;
        Serial.println(ArraymaxAngeleFromEx3[iterator]);
        tempMaxAngeleFromEx3 = 0;
        Serial.println("COUNTERRRRRRRRR");
        ArrayCountNumFromEx3[iterator] = counter;
        Serial.println(ArrayCountNumFromEx3[iterator]);
        tempMaxAngeleFromEx3 = 0;
        counter = 0;
        iterator ++;
        previousMillis2 = currentMillis;
        
      }
      //output for the user which inform that 1 minute pass and turn the relevant light
      if(currentMillis - startEx >= 59800 && currentMillis - startEx <= 60300) {
        CircuitPlayground.setPixelColor(9, 0, 255, 0);
      }
      Serial.print("y:");
      double y = CircuitPlayground.motionY();
      Serial.println(y);
      //measre the current max Y and convert to angle
      tempMaxAngeleFromEx3  = max(tempMaxAngeleFromEx3 , (y + 9) * 10);
      Serial.println(tempMaxAngeleFromEx3);
      delay(300);
      if (y > 3){
        counter++;
        delay(500);
      }
    //if the user shouts into the CPX alert will be sent
    double temp = CircuitPlayground.temperature();
    Serial.print("temp:");
    Serial.println(temp);
    if(temp > 35){
      emergency(temp);
      CircuitPlayground.setPixelColor(9, 0, 0, 0);
      return false;
   }
    }
    //the user Finish the exericse and play music for acknowledging the user that he finish the exericse, and turn the relevant light
    CircuitPlayground.setPixelColor(8, 0, 255, 0);
    CircuitPlayground.playTone(500, 1100, false);

    //put the max bertween the all maximum values into to maxAngeleFromEx1 value
    for(int i = 0; i < 4; i++) {
       maxAngeleFromEx3 = max(maxAngeleFromEx3, ArraymaxAngeleFromEx3[i]);
    }
    Serial.println("maxAngle");
    Serial.println(ArraymaxAngeleFromEx3[0]);
    Serial.println(ArraymaxAngeleFromEx3[1]);
    Serial.println(ArraymaxAngeleFromEx3[2]);
    Serial.println(ArraymaxAngeleFromEx3[3]);
    Serial.println("count");
    Serial.println(ArrayCountNumFromEx3[0]);
    Serial.println(ArrayCountNumFromEx3[1]);
    Serial.println(ArrayCountNumFromEx3[2]);
    Serial.println(ArrayCountNumFromEx3[3]);
    return true;
}

  
bool exLeg2() {
    delay(2000);
    unsigned long startEx = millis();
    unsigned long previousMillis1 = millis() + 15000;
    unsigned long currentMillis = millis();
    bool measrue = false;
    int iterator = -1;
    while(currentMillis - startEx < 10600) {
         Blynk.run();
          currentMillis = millis();
         if(currentMillis - previousMillis1 > 15000 && iterator < 4) {
        //that how the user know to stop / continue the exerices
        CircuitPlayground.playTone(300, 200, false);
        previousMillis1 = currentMillis;
        measrue = !(measrue);
        if(measrue) {
          iterator ++;
        }
        delay(2000);
      }
      if(measrue){
        double y = CircuitPlayground.motionY();
        Serial.println(y);
        if(y < 4) {
          Serial.println("the user takes his leg off");
          theUserSteelWithTheLegUp[iterator] = false;
        }
      }
       //output for the user which inform that 1 minute pass and turn the relevant light
      if(currentMillis - startEx >= 59800 && currentMillis - startEx <= 60100) {
        CircuitPlayground.setPixelColor(7, 0, 255, 0);
      }
     //if the user shouts into the CPX alert will be sent
    double temp = CircuitPlayground.temperature();
    Serial.print("temp:");
    Serial.println(temp);
    if(temp > 35){
      emergency(temp);
      CircuitPlayground.setPixelColor(7, 0, 0, 0);
      return false;
      }
    }
      //the user Finish the exericse and play music for acknowledging the user that he finish the exericse, and turn the relevant light
      CircuitPlayground.setPixelColor(6, 0, 255, 0);
      CircuitPlayground.playTone(500, 1100, false);
      Serial.println("results");
      for(int i = 0; i < 4; i++) {
        Serial.println(theUserSteelWithTheLegUp[i]);
      }
      return true;
}

bool exHand2() {
    delay(1500);
    unsigned long startEx = millis();
    unsigned long previousMillis1 = millis() + 15000;
    unsigned long currentMillis = millis();
    bool measrue = false;
    int iterator = -1;
    while(currentMillis - startEx < 10600) {
          Blynk.run();
          currentMillis = millis();
         if(currentMillis - previousMillis1 > 15000 && iterator < 4) {
        //that how the user know to stop / continue the exerices
        CircuitPlayground.playTone(300, 200, false);
        previousMillis1 = currentMillis;
        measrue = !(measrue);
        if(measrue) {
          iterator ++;
        }
        delay(2000);
      }
      if(measrue){
        double y = CircuitPlayground.motionY();
        Serial.println(y);
        if(y < -3) {
          Serial.println("the user takes his hand off");
          theUserSteelWithTheHandUp[iterator] = false;
        }
      }
       //output for the user which inform that 1 minute pass and turn the relevant light
      if(currentMillis - startEx >= 59800 && currentMillis - startEx <= 60100) {
        CircuitPlayground.setPixelColor(2, 0, 255, 0);
      }
    //if the user shouts into the CPX alert will be sent
    double sound = CircuitPlayground.soundSensor()();
    Serial.print("sound:");
    Serial.println(sound);
    if(sound > 150){
      emergency(sound);
      CircuitPlayground.setPixelColor(2, 0, 0, 0);
      return false;
      }
    }
      //the user Finish the exericse and play music for acknowledging the user that he finish the exericse, and turn the relevant light
      CircuitPlayground.setPixelColor(3, 0, 255, 0);
      CircuitPlayground.playTone(500, 1100, false);
      Serial.println("results");
      for(int i = 0; i < 4; i++) {
        Serial.println(theUserSteelWithTheHandUp[i]);
      }
      return true;
}

bool exHand1() {
    delay(1500);
    //varible declarations
    double tempMaxAngeleFromEx1 = 0;
    int iterator = 0;
    int counter = 0;
    unsigned long startEx = millis();
    unsigned long previousMillis1 = millis() + 15000;
    unsigned long previousMillis2 = millis(); 
    unsigned long currentMillis = millis();
    //the exerise should be 2 minutes
    while(currentMillis - startEx < 12500) {
      Blynk.run();
      currentMillis = millis();
      //every 15 secoends the user should stop / continue the exerices
      if(currentMillis - previousMillis1 > 15000) {
        //that how the user know to stop / continue the exerices
        CircuitPlayground.playTone(300, 200, false);
        previousMillis1 = currentMillis;
      }
      //measure the max angel for every iterval of 30 seconds, and saving this data into array for the therpiset
       if(currentMillis - previousMillis2 > 30000) {
        Serial.println("MAXXXXXXXX");
        ArraymaxAngeleFromEx1[iterator] = tempMaxAngeleFromEx1;
        Serial.println(ArraymaxAngeleFromEx1[iterator]);
        tempMaxAngeleFromEx1 = 0;
        Serial.println("COUNTERRRRRRRRR");
        ArrayCountNumFromEx1[iterator] = counter;
        Serial.println(ArrayCountNumFromEx1[iterator]);
        tempMaxAngeleFromEx1 = 0;
        counter = 0;
        iterator ++;
        previousMillis2 = currentMillis;
        
      }
      //output for the user which inform that 1 minute pass and turn the relevant light
      if(currentMillis - startEx >= 59800 && currentMillis - startEx <= 60300) {
        CircuitPlayground.setPixelColor(0, 0, 255, 0);
      }
      Serial.print("y:");
      double y = CircuitPlayground.motionY();
      Serial.println(y);
      //measre the current max Y and convert to angle
      tempMaxAngeleFromEx1  = max(tempMaxAngeleFromEx1 , (y + 9) * 10);
      Serial.println(tempMaxAngeleFromEx1 );
      delay(300);
      if (y > -1){
        counter++;
        delay(500);
      }
     //if the user shouts into the CPX alert will be sent
    double sound = CircuitPlayground.soundSensor();
    double temp = CircuitPlayground.temperature();
    Serial.print("temp:");
    Serial.println(temp);
    if(temp > 35){
      emergency(temp);
      CircuitPlayground.setPixelColor(0, 0, 0, 0);
      //the user not finished the exercise
      return false;
      }
    }
    //the user Finish the exericse and play music for acknowledging the user that he finish the exericse, and turn the relevant light
    CircuitPlayground.setPixelColor(1, 0, 255, 0);
    CircuitPlayground.playTone(500, 1100, false);

    //put the max bertween the all maximum values into to maxAngeleFromEx1 value
    for(int i = 0; i < 4; i++) {
       maxAngeleFromEx1 = max(maxAngeleFromEx1, ArraymaxAngeleFromEx1[i]);
    }
    Serial.println("maxAngle");
    Serial.println(ArraymaxAngeleFromEx1[0]);
    Serial.println(ArraymaxAngeleFromEx1[1]);
    Serial.println(ArraymaxAngeleFromEx1[2]);
    Serial.println(ArraymaxAngeleFromEx1[3]);
    Serial.println("count");
    Serial.println(ArrayCountNumFromEx1[0]);
    Serial.println(ArrayCountNumFromEx1[1]);
    Serial.println(ArrayCountNumFromEx1[2]);
    Serial.println(ArrayCountNumFromEx1[3]);
    //the user finished his exercise with sucsses
    return true;
}


//convert the all results to one long string
void writeData(){
  
  //convert results to strins and put leading "0" if need.
  String tempArraymaxAngeleFromEx1 [4];
  String tempArraymaxAngeleFromEx3 [4];
  String tempArrayCountNumFromEx1 [4];
  String tempArrayCountNumFromEx3 [4];

  //insert leading "0"
  for(int i = 0; i < 4; i++) {
    
    tempArraymaxAngeleFromEx1[i] =  String (int(ArraymaxAngeleFromEx1[i]));
    if(tempArraymaxAngeleFromEx1[i].length() < 3) {
      if(tempArraymaxAngeleFromEx1[i].length() == 2) {
        tempArraymaxAngeleFromEx1[i] = "0" + tempArraymaxAngeleFromEx1[i];
      }
      else {
        tempArraymaxAngeleFromEx1[i] = "00" + tempArraymaxAngeleFromEx1[i];
      }
    }

    tempArraymaxAngeleFromEx3[i] =  String (int(ArraymaxAngeleFromEx3[i]));
    if(tempArraymaxAngeleFromEx3[i].length() < 3) {
        if(tempArraymaxAngeleFromEx3[i].length() == 2) {
          tempArraymaxAngeleFromEx3[i] = "0" + tempArraymaxAngeleFromEx3[i];
        }
        else {
          tempArraymaxAngeleFromEx3[i] = "00" + tempArraymaxAngeleFromEx3[i];
        }
    }
  
    tempArrayCountNumFromEx1[i] =  String (ArrayCountNumFromEx1[i]);
    if(tempArrayCountNumFromEx1[i].length() < 3) {
        if(tempArrayCountNumFromEx1[i].length() == 2) {
          tempArrayCountNumFromEx1[i] = "0" + tempArrayCountNumFromEx1[i];
        }
        else {
          tempArrayCountNumFromEx1[i] = "00" + tempArrayCountNumFromEx1[i];
        }
    }
  
    tempArrayCountNumFromEx3[i] =  String (ArrayCountNumFromEx3[i]);
    if(tempArrayCountNumFromEx3[i].length() < 3) {
        if(tempArrayCountNumFromEx3[i].length() == 2) {
          tempArrayCountNumFromEx3[i] = "0" + tempArrayCountNumFromEx3[i];
        }
        else {
          tempArrayCountNumFromEx3[i] = "00" + tempArrayCountNumFromEx3[i];
        }
    }
  }


  //convert results to strins and put leading "0" if need.
  String TempmaxAngeleFromEx1 = String (int(maxAngeleFromEx1));
  if(TempmaxAngeleFromEx1.length() < 3) {
    if(TempmaxAngeleFromEx1.length() == 2) {
      TempmaxAngeleFromEx1 = "0" + TempmaxAngeleFromEx1;
    }
    else {
      TempmaxAngeleFromEx1 = "00" + TempmaxAngeleFromEx1;
    }
  }
  
  //convert results to strins and put leading "0" if need.
  String TempmaxAngeleFromEx3 = String (int(maxAngeleFromEx3));
  if(TempmaxAngeleFromEx3.length() < 3) {
    if(TempmaxAngeleFromEx3.length() == 2) {
      TempmaxAngeleFromEx3 = "0" + TempmaxAngeleFromEx3;
    }
    else {
      TempmaxAngeleFromEx3 = "00" + TempmaxAngeleFromEx3;
    }
  }
  
  //concatStrings
  String result1 = "$" + tempArraymaxAngeleFromEx1[0] + "$" + tempArraymaxAngeleFromEx1[1] + "$" + tempArraymaxAngeleFromEx1[2] + "$" + tempArraymaxAngeleFromEx1[3] + "$" + TempmaxAngeleFromEx1 + "$" + tempArrayCountNumFromEx1[0] + "$" +  tempArrayCountNumFromEx1[1] + "$" + tempArrayCountNumFromEx1[2] + "$" + tempArrayCountNumFromEx1[3];
  String result2 = "$" + String (theUserSteelWithTheHandUp[0]) + "$" + String (theUserSteelWithTheHandUp[1])+ "$" + String (theUserSteelWithTheHandUp[2]) + "$" + String (theUserSteelWithTheHandUp[3]);
  String result3 =  "$" + tempArraymaxAngeleFromEx3[0] + "$" + tempArraymaxAngeleFromEx3[1] + "$" + tempArraymaxAngeleFromEx3[2] + "$" + tempArraymaxAngeleFromEx3[3] + "$" + TempmaxAngeleFromEx3 + "$" + tempArrayCountNumFromEx3[0] + "$" +tempArrayCountNumFromEx3[1] + "$" + tempArrayCountNumFromEx3[2] + "$" + tempArrayCountNumFromEx3[3];
  String result4 = "$" + String (theUserSteelWithTheLegUp[0]) + "$" + String (theUserSteelWithTheLegUp[1]) + "$" + String (theUserSteelWithTheLegUp[2]) + "$" + String (theUserSteelWithTheLegUp[3]);
  result = result1 + result2 + result3 + result4;
  
}

  
//function that open a red light and emergency sound
void emergency(double sound) {
    Blynk.virtualWrite(V6 , 1);
    Serial.println("SOUNDDDDDDDD");
    Serial.println(sound);
    while(true){
      for(int i=0 ; i<10 ; i++){
        CircuitPlayground.setPixelColor(i, 255, 0, 0);
      }
      delay(300);
       for(int i=0 ; i<10 ; i++){
        CircuitPlayground.setPixelColor(i, 0, 0, 0);
      }
        CircuitPlayground.playTone(300, 200, false);
       if(CircuitPlayground.rightButton()){
        delay(1500);
        break;
       }
    }
}

//write the processing value of the hand angle to varible
BLYNK_WRITE(V1) {
int pinValue = param.asInt(); // assigning incoming value from pin V1 to a variable
 processFromLastTimeHand = pinValue;
}

//write the processing value of the leg angle to varible
BLYNK_WRITE(V2) {
int pinValue = param.asInt(); // assigning incoming value from pin V1 to a variable
processFromLastTimeLeg = pinValue;
}

  
